'use client';
import { useState } from 'react';
import { Button, Disclosure, DisclosurePanel, Heading } from 'react-aria-components';
/**
 * Display an interactive OpenAPI disclosure.
 */
export function OpenAPIDisclosure(props) {
    var context = props.context, children = props.children, label = props.label;
    var _a = useState(false), isExpanded = _a[0], setIsExpanded = _a[1];
    return (<Disclosure className="openapi-disclosure" isExpanded={isExpanded} onExpandedChange={setIsExpanded}>
            <Heading>
                <Button slot="trigger" className="openapi-disclosure-trigger" style={function (_a) {
            var isFocusVisible = _a.isFocusVisible;
            return ({
                outline: isFocusVisible
                    ? '2px solid rgb(var(--primary-color-500) / 0.4)'
                    : 'none',
            });
        }}>
                    {context.icons.plus}
                    <span>
                        {isExpanded ? 'Hide' : 'Show'} {label}
                    </span>
                </Button>
            </Heading>
            <DisclosurePanel className="openapi-disclosure-panel">
                {isExpanded ? children : null}
            </DisclosurePanel>
        </Disclosure>);
}
