import { type Key, type TabsProps } from 'react-aria-components';
export type TabItem = {
    key: Key;
    label: string;
    body: React.ReactNode;
    footer?: React.ReactNode;
};
/**
 * The OpenAPI Tabs wrapper component.
 */
export declare function OpenAPITabs(props: React.PropsWithChildren<TabsProps & {
    items: TabItem[];
    stateKey?: string;
}>): import("react").JSX.Element;
/**
 * The OpenAPI Tabs list component.
 * This component should be used as a child of the OpenAPITabs component.
 * It renders the list of tabs.
 */
export declare function OpenAPITabsList(): import("react").JSX.Element;
/**
 * The OpenAPI Tabs panels component.
 * This component should be used as a child of the OpenAPITabs component.
 * It renders the content of the selected tab.
 */
export declare function OpenAPITabsPanels(): import("react").JSX.Element | null;
