import clsx from 'clsx';
import { forwardRef } from 'react';
export function Section(props) {
    return <div {...props} className={clsx('openapi-section', props.className)}/>;
}
export function SectionHeader(props) {
    return (<div {...props} className={clsx('openapi-section-header', props.className && "".concat(props.className, "-header"))}/>);
}
export function SectionHeaderContent(props) {
    return (<div {...props} className={clsx('openapi-section-header-content', props.className && "".concat(props.className, "-header-content"))}/>);
}
export var SectionBody = forwardRef(function SectionBody(props, ref) {
    return (<div ref={ref} {...props} className={clsx('openapi-section-body', props.className && "".concat(props.className, "-body"))}/>);
});
export function StaticSection(props) {
    var className = props.className, header = props.header, children = props.children;
    return (<Section className={className}>
            <SectionHeader className={className}>
                <SectionHeaderContent className={className}>{header}</SectionHeaderContent>
            </SectionHeader>
            <SectionBody className={className}>{children}</SectionBody>
        </Section>);
}
