import { fromJSON, toJSON } from 'flatted';
import type { Filesystem, OpenAPIV3xDocument } from '@gitbook/openapi-parser';
import type { OpenAPIOperationData } from './types';
export { fromJSON, toJSON };
/**
 * Resolve an OpenAPI operation in a file and compile it to a more usable format.
 */
export declare function resolveOpenAPIOperation(filesystem: Filesystem<OpenAPIV3xDocument>, operationDescriptor: {
    path: string;
    method: string;
}): Promise<OpenAPIOperationData | null>;
