import type { Filesystem, OpenAPIV3xDocument } from '@gitbook/openapi-parser';
import type { OpenAPISchemasData } from '../types';
/**
 * Resolve an OpenAPI schemas from a file and compile it to a more usable format.
 * Schemas are extracted from the OpenAPI components.schemas
 */
export declare function resolveOpenAPISchemas(filesystem: Filesystem<OpenAPIV3xDocument>, options: {
    schemas: string[];
}): Promise<OpenAPISchemasData | null>;
