'use client';
import { createStore } from 'zustand';
var createTabStore = function (initialTab) {
    return createStore()(function (set) { return ({
        tabKey: initialTab !== null && initialTab !== void 0 ? initialTab : null,
        setTabKey: function (tabKey) {
            set(function () { return ({ tabKey: tabKey }); });
        },
    }); });
};
var defaultTabStores = new Map();
var createTabStoreFactory = function (stores) {
    return function (storeKey, initialKey) {
        if (!stores.has(storeKey)) {
            stores.set(storeKey, createTabStore(initialKey));
        }
        return stores.get(storeKey);
    };
};
export var getOrCreateTabStoreByKey = createTabStoreFactory(defaultTabStores);
